async function redirect(url) {
	// If we can't execute a script (privileged tab or whatever), close the current tab and open a new one with the correct url
	await chrome.tabs.create({url});
}

chrome.action.onClicked.addListener(async () => {
	let username = (await chrome.storage.local.get("username")).username;
	let password = (await chrome.storage.local.get("password")).password;
	if(!username || !password) {
		return await redirect("/config.html");
	}

	// Send request to the librus.rozbrajacz.futbol API
	let resp, startTime, endTime;
		startTime = Date.now();
		// resp = await fetch((DEBUG? 'http://127.0.0.1:6969' : 'https://librus.rozbrajacz.futbol') + '/api/login', {method: 'POST', headers: {Authorization: `Librus ${btoa(username + ':' + password)}`}, 'X-Addon-Version': 'beta-testing'});
		resp = await fetch('https://librus.rozbrajacz.futbol/api/login', {method: 'POST', headers: {Authorization: `Librus ${btoa(username + ':' + password)}`}, 'X-Addon-Version': 'beta-testing'});
		endTime = Date.now();
	console.log(`${endTime - startTime}ms`)
	let body = await resp.text();
	if(resp.status != 200) return console.log(`Error - status code ${resp.status}; response - ${body}`);
	for(let cookie of body.replaceAll(/set-cookie:[ \t]*/gi, '').split("\r\n").filter(_ => _)) {
		let cookieData = {};
		let [kv, ...attributes] = cookie.split('; ');
		let [name, value] = kv.split('=');
		cookieData.url = 'https://synergia.librus.pl';
		cookieData.name = name;
		cookieData.value = value;
		for(let attribute of attributes) {
			let [key, val] = attribute.split('=');
			switch(key) {
				case 'SameSite':
					if(val == 'None') break;
					cookieData.sameSite = val.toLowerCase();
					break;
				case 'secure':
					cookieData.secure = true;
					break;
				case 'path':
					cookie.path = val;
					break;
				case 'HttpOnly':
					cookie.httpOnly = true;
					break;
				case 'expires':
					// This technically doesn't parse according to spec, but it parses what librus sends back ._.
					let [dow, dmy, time, gmt] = val.split(' ');
					let [day, month, year] = dmy.split('-');
					let months = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
					let ISO8601 = `${year}-${(months.indexOf(month) + 1).toString().padStart(2, '0')}-${day}T${time}Z`
					// console.log(val);
					// console.log(ISO8601);
					// console.log(new Date(ISO8601).getTime() / 1000);
					cookieData.expirationDate = new Date(ISO8601).getTime() / 1000;
					break;
				case 'Max-Age':
					break; // cookies.set doesn't have it afaik, just ignore it here
			}
		}

		await chrome.cookies.set(cookieData); // hopefully this works ¯\_(ツ)_/¯
	}
	await redirect('https://synergia.librus.pl/uczen/index');
});
